%define gettext_package metacity

Summary: Metacity window manager
Name: metacity
Version: 2.4.55
Release: 7.26.XOS.1
URL: http://people.redhat.com/~hp/metacity/
Source0: %{name}-%{version}.tar.bz2
License: GPL
Group: User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: gtk2-devel >= 2.2.0
BuildRequires: pango-devel >= 1.2.0
BuildRequires: fontconfig-devel
BuildRequires: GConf2-devel >= 2.2.0
BuildRequires: desktop-file-utils >= 0.3
BuildRequires: libglade2-devel >= 2.0.0
BuildRequires: intltool >= 0.22
BuildRequires: startup-notification-devel >= 0.5
BuildRequires: perl

Requires: redhat-artwork >= 0.62

Patch0: metacity-2.3.987-default-theme.patch
Patch1: metacity-2.3.987.92-system-font.patch
Patch2: metacity-2.4.13.90-ctrlaltdel.patch
Patch3: metacity-2.4.55-size-fix.patch
Patch4: metacity-2.4.55-button-down.patch
Patch5: metacity-2.4.55-resources-backport.patch
Patch6: metacity-2.4.55-event-serials.patch
Patch7: metacity-2.4.55-unshade-artifact.patch
Patch8: metacity-2.4.55-raise-on-click.patch
Patch9: metacity-2.4.55-strict-pointer-mode.patch
Patch10: metacity-2.4.55-wireframe-drawing.patch
Patch11: metacity-2.4.55-unwireframe-before-ungrab.patch
Patch12: metacity-2.4.55-no-ignored-serial.patch
Patch13: metacity-2.4.55-lost-focus.patch
Patch14: metacity-2.4.55-fullscreen-xinerama.patch
Patch15: metacity-2.4.55-ignore-partial-width-struts.patch
Patch16: metacity-2.4.55-other-unshade-artifact.patch
Patch17: metacity-2.4.55-check-for-fast-mouse-up-events.patch
Patch18: metacity-2.4.55-wireframe-resize-popup.patch
Patch19: metacity-2.4.55-fix-up-keyboard-resize-and-move.patch
Patch20: metacity-2.4.55-note-failed-pointer-grabs.patch

%description

Metacity is a simple window manager that integrates nicely with 
GNOME 2.

%prep
%setup -q

%patch0 -p1 -b .default-theme
%patch1 -p1 -b .system-font
%patch2 -p1 -b .ctrlaltdel
%patch3 -p1 -b .size-fix
%patch4 -p1 -b .button-down
%patch5 -p0 -b .resources-backport
%patch6 -p1 -b .event-serials
%patch7 -p0 -b .unshade-artifact
%patch8 -p0 -b .raise-on-click
%patch9 -p1 -b .strict-pointer-mode
%patch10 -p1 -b .wireframe-drawing
%patch11 -p1 -b .unwireframe-before-ungrab
%patch12 -p1 -b .no-ignored-serial
%patch13 -p1 -b .lost-focus
%patch14 -p1 -b .fullscreen-xinerama
%patch15 -p1 -b .ignore-partial-width-struts
%patch16 -p1 -b .other-unshade-artifact
%patch17 -p1 -b .check-for-fast-mouse-up-events
%patch18 -p1 -b .wireframe-resize-popup
%patch19 -p1 -b .fix-up-keyboard-resize-and-move
%patch20 -p1 -b .note-failed-pointer-grabs

%build
%configure

## intltool munges metacity.schemas in UTF-8 locale
## http://bugzilla.gnome.org/show_bug.cgi?id=91289
## force regeneration with intltool in non-UTF-8 locale
rm -f src/metacity.schemas
rm -f po/.intltool-merge-cache
LANG=en_US.ISO-8859-1 make ## %{?_smp_mflags}

SHOULD_HAVE_DEFINED="HAVE_SM HAVE_XINERAMA HAVE_XFREE_XINERAMA HAVE_SHAPE HAVE_RANDR HAVE_STARTUP_NOTIFICATION"

for I in $SHOULD_HAVE_DEFINED; do
  if ! grep -q "define $I" config.h; then
    echo "$I was not defined in config.h"
    grep "$I" config.h
    exit 1
  else
    echo "$I was defined as it should have been"
    grep "$I" config.h
  fi
done

%install
rm -rf $RPM_BUILD_ROOT

export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
%makeinstall
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

/bin/rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%find_lang %{gettext_package}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
SCHEMAS="metacity.schemas"
for S in $SCHEMAS; do
  gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/$S > /dev/null
done

%postun -p /sbin/ldconfig

%files -f %{gettext_package}.lang
%defattr(-,root,root)
%doc README AUTHORS COPYING NEWS HACKING doc/theme-format.txt doc/metacity-theme.dtd
%{_bindir}/*
%{_libexecdir}/*
%{_datadir}/gnome/wm-properties/metacity.desktop
%{_sysconfdir}/gconf/schemas/*.schemas
%{_datadir}/metacity
%{_datadir}/themes
%{_datadir}/pixmaps
%{_includedir}/*
%{_libdir}/lib*.so*
%{_libdir}/lib*.a
%{_libdir}/pkgconfig/*

%changelog
* Fri Mar 24 2006 X/OS Linux Team <xoslinux@xos.nl> 2.4.55-7.26.XOS.1
- Build for X/OS Linux 3.0.
- X/OS Linux source rpm based on metacity-2.4.55-7.26.src.rpm
  (md5sum of original source rpm: 9683ee474c7400d3ef2f277801b122a9).

* Fri Sep 23 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.26
- pair error_pop_with_return with push_with_return instead of push

* Fri Sep 23 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.25
- Fail grab op if unable to get pointer grab (bug 158900)

* Mon Sep 19 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.24
- Initialize wireframe mode state to false initially
  (bug 167826)

* Thu Aug 17 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.23
- fix crash on startup (bug 166169)

* Thu Aug  4 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.22
- Make keyboard move behavior more sane in shaded mode.
- Disable keyboard resize in shaded mode.

* Fri Jul 29 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.21
- Add updated patch from gnome bug 310888.

* Fri Jul 22 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.20
- Fix up some more problems with the resize popup patch
  (bug 164000)

* Wed Jul 20 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.19
- Fix edge snapping in wireframe mode (bug 130088)
- Fix mouse resizing and moving (bug 156894)
- Impove resize popup patch

* Thu May 26 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.18
- Draw resize popup in wireframe mode (bug #156293).

* Wed May 11 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.17
- Don't ignore fast ButtonRelease events (bug #146195).

* Thu Mar 31 2005 Ray Strode <rstrode@redhat.com> - 2.4.55-7.16
- In reduced resources mode, clean up the entire wireframe on unshade, 
  not just the part inside of the window frame (bug #152933).

* Wed Nov  3 2004 Mark McLoughlin <markmc@redhat.com> - 2.4.55-7.15
- Add workaround patch to add an ignore_partial_width_struts pref to
  allow partial width panels to be ignored when calculating position
  constraints (bug #135589)

* Thu Oct 28 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.14
- tweak the last fix to also keep fullscreen on top when no focus window exists

* Thu Oct 28 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.13
- fix for #136208 (don't lower fullscreen windows when other head is focused)

* Wed Oct 27 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.12
- add PropertyChangeMask to display leader window to avoid blocking on XWindowEvent() after fixing focus = None, bug #137062  

* Mon Oct  4 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.11
- add patch to put focus back somewhere if it lands at None

* Sat Aug 21 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.10
- when in strict_pointer_mode don't do the ignored_serial stuff, this may be a bad idea, but trying it

* Sat Aug 21 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.9
- fix a bug I created in the unwireframe-before-ungrab patch, which made
  a big mess when moving/resizing

* Thu Aug 19 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.8
- add patch from Soeren Sandmann to fix flicker when dragging a wireframe window over a fullscreen window

* Wed Aug 18 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.7
- -7.6 build didn't pull in the intended fixes, so was really the same as -7.5; now fixed
- add attempted fix for drawing wireframes correctly, IT_38258 and IT_37074

* Wed Aug 18 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.6
- avoid one more focus heuristic; and fix schema for strict_pointer_mode

* Tue Aug 17 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.5
- remove focus-on-map-pref, replace with strict-pointer-mode

* Mon Jul 12 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.4
- only raise on click when raise_on_click setting is true, even if the button click was mouse 2 or mouse 3

* Wed Jun 23 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.3
- add a raise on click setting for working around a customer app;
  to be phased out over time

* Wed Jun 16 2004 Havoc Pennington <hp@redhat.com> - 2.4.55-7.2
- add hacky "no focus on map" pref pending _NET_WM_USER_TIME patch in GNOME 2.8
  (feature #121347)
- add fix for artifact on unshade from Bernd Schmidt, bug #121549 feature
  #122061

* Mon Apr 19 2004 Havoc Pennington <hp@redhat.com> 2.4.55-7.1
- add patch from http://bugzilla.gnome.org/show_bug.cgi?id=136587 for testing

* Mon Jul 28 2003 Havoc Pennington <hp@redhat.com> 2.4.55-7
- rebuild

* Mon Jul 28 2003 Havoc Pennington <hp@redhat.com> 2.4.55-6
- backport the "reduced_resources" patch with wireframe

* Mon Jul 07 2003 Christopher Blizzard <blizzard@redhat.com> 2.4.55-4
- add patch to fix mouse down problems in mozilla

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu May 29 2003 Havoc Pennington <hp@redhat.com> 2.4.55-2
- rebuild

* Thu May 29 2003 Havoc Pennington <hp@redhat.com> 2.4.55-1
- 2.4.55

* Wed May 14 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- add proper ldconfig calls for shared libs

* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 21 2003 Havoc Pennington <hp@redhat.com> 2.4.34-2
- fix a crash in multihead situations, #84412

* Wed Feb  5 2003 Havoc Pennington <hp@redhat.com> 2.4.34-1
- 2.4.34
- try disabling smp_mflags and see if it fixes build

* Wed Jan 22 2003 Havoc Pennington <hp@redhat.com>
- 2.4.21.90 with a bunch o' fixes

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Jan 16 2003 Havoc Pennington <hp@redhat.com>
- bind Ctrl+Alt+Del to logout, #72973

* Wed Jan 15 2003 Havoc Pennington <hp@redhat.com>
- 2.4.13.90 cvs snap with event queue lag fix

* Fri Jan 10 2003 Havoc Pennington <hp@redhat.com>
- 2.4.13

* Thu Dec 12 2002 Havoc Pennington <hp@redhat.com>
- 2.4.8

* Mon Dec  2 2002 Havoc Pennington <hp@redhat.com>
- 2.4.5.90
- add little script after configure that checks what config.h
  contains, to be sure we detected all the right features.

* Tue Oct 29 2002 Havoc Pennington <hp@redhat.com>
- 2.4.3
- remove patches that have gone upstream

* Tue Aug 27 2002 Havoc Pennington <hp@redhat.com>
- fix shaded window decorations in Bluecurve theme

* Sat Aug 24 2002 Havoc Pennington <hp@redhat.com>
- fix the mplayer-disappears-on-de-fullscreen bug

* Sat Aug 24 2002 Havoc Pennington <hp@redhat.com>
- add some fixes from CVS for #71163 #72379 #72478 #72513

* Thu Aug 22 2002 Havoc Pennington <hp@redhat.com>
- patch .schemas.in instead of .schemas so we get right default theme/fonts

* Tue Aug 20 2002 Havoc Pennington <hp@redhat.com>
- grow size of top resize, and display proper cursor on enter notify
- require latest intltool to try and fix metacity.schemas by
  regenerating it in non-UTF-8 locale

* Thu Aug 15 2002 Havoc Pennington <hp@redhat.com>
- default to Sans Bold font, fixes #70920 and matches graphic design spec

* Thu Aug 15 2002 Havoc Pennington <hp@redhat.com>
- 2.4.0.91 with raise/lower keybindings for msf, fixes to fullscreen
- more apps that probably intend to be, fix for changing number of
  workspaces, fix for moving windows in multihead

* Tue Aug 13 2002 Havoc Pennington <hp@redhat.com>
- update build requires

* Mon Aug 12 2002 Havoc Pennington <hp@redhat.com>
- upgrade to cvs snap 2.4.0.90 with pile of bugfixes from 
  this weekend
- change default theme to bluecurve and require new redhat-artwork

* Tue Aug  6 2002 Havoc Pennington <hp@redhat.com>
- 2.4.0
- themes are moved, require appropriate redhat-artwork

* Thu Aug  1 2002 Havoc Pennington <hp@redhat.com>
- munge the desktop file to be in toplevel menus and 
  not show in KDE

* Tue Jul 23 2002 Havoc Pennington <hp@redhat.com>
- don't use system font by default as metacity's 
  font is now in the system font dialog

* Tue Jul 23 2002 Havoc Pennington <hp@redhat.com>
- 2.3.987.92 cvs snap

* Fri Jul 12 2002 Havoc Pennington <hp@redhat.com>
- 2.3.987.91 cvs snap

* Mon Jun 24 2002 Havoc Pennington <hp@redhat.com>
- 2.3.987.90 cvs snap

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sun Jun 16 2002 Havoc Pennington <hp@redhat.com>
- rebuild for new libraries

* Mon Jun 10 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Mon Jun 10 2002 Havoc Pennington <hp@redhat.com>
- 2.3.987
- default to redhat theme

* Fri Jun 07 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Tue Jun  4 2002 Havoc Pennington <hp@redhat.com>
- 2.3.610.90 cvs snap

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 20 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Fri May 17 2002 Havoc Pennington <hp@redhat.com>
- 2.3.377

* Thu May  2 2002 Havoc Pennington <hp@redhat.com>
- 2.3.233

* Thu Apr 25 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment
- add gconf schemas boilerplate

* Mon Apr 15 2002 Havoc Pennington <hp@pobox.com>
- 2.3.89

* Tue Oct 30 2001 Havoc Pennington <hp@redhat.com>
- 2.3.34

* Fri Oct 13 2001 Havoc Pennington <hp@redhat.com>
- 2.3.21 

* Mon Sep 17 2001 Havoc Pennington <hp@redhat.com>
- 2.3.8
- 2.3.13

* Wed Sep  5 2001 Havoc Pennington <hp@redhat.com>
- Initial build.


